//------------------------------------
// "256 chix dig dat"
// 256 bytes exe gfx
// by wacek/arise
//
// image based on "chix dig dat"
// https://csdb.dk/release/?id=91029
//------------------------------------

.var from 	= $a0		// + $a1
.var to   	= $a2		// + $a3
.var screen = $0455 

			* = $1000
			
			sei

			lda #<screen
			sta to
			lda #>screen
			sta to + 1
			lda #<data
			sta from
			lda #>data
			sta from + 1

			sta $0286
			jsr $e544

			stx $d020
			stx $d021

			ldy #0
			
depack_loop:			

			// start from literal sequence

			lda (from),y
			tay
			sta from_here
			sta to_here
!loop:		
			lda (from),y
			sta (to),y
			dey
			bne !loop-

			jsr inc_from
			jsr inc_to
			
			// then do rle / skipping
			
			lda (from),y
			
			// if = 0 then end
			
			beq *
			
			sta to_here
			jsr inc_to

			sty from_here
			jsr inc_from

			jmp depack_loop

//------------------------------------
// subroutines
//------------------------------------

inc_from:	
			sec
			lda from
			adc from_here: #$00
			sta from
			rts

inc_to:		
			lda to
			adc to_here: #$00 						
			sta to
			bcc !skip+
			inc to + 1
!skip:		
			rts

//------------------------------------
// packed petscii image
//------------------------------------

data:		
			.import binary "assets\spacepacked.uniqued.chix07.dat",1,160
			.byte 0,$6,$66 // ;)

//------------------------------------
// all ends here.
//------------------------------------